package com.perforce.p4java.impl.mapbased.rpc.func.client;

import java.util.HashMap;
import java.util.Map;

import com.perforce.p4java.impl.mapbased.rpc.CommandEnv;

/**
 * @author Sean Shou
 * @since 26/08/2016
 */
public class ClientHelper {
  private ClientHelper() { /* util */ }

  /**
   * Send back the data bytes written (accumulated)
   * This is for the progress indicator
   */
  public static long sendBackWrittenDataBytes(
      final CommandEnv cmdEnv,
      final String filePath,
      final long fileSize,
      final long currentSize,
      final long bytesRead) {
    long totalReadSize = currentSize;
    if (cmdEnv.getProtocolSpecs().isEnableProgress()) {
      if (fileSize > 0 && bytesRead > 0) {
        totalReadSize += bytesRead;
        Map<String, Object> dataSizeMap = new HashMap<String, Object>();
        dataSizeMap.put("path", filePath);
        dataSizeMap.put("fileSize", fileSize);
        dataSizeMap.put("currentSize", totalReadSize);
        cmdEnv.handleResult(dataSizeMap);
      }
    }

    return totalReadSize;
  }
}
