package com.perforce.p4java.common.io;

import static org.hamcrest.MatcherAssert.assertThat;
import static org.hamcrest.core.Is.is;

import java.io.File;

import org.junit.Test;

import com.perforce.p4java.AbstractP4JavaUnitTest;

/**
 * @author Sean Shou
 * @since 25/08/2016
 */
public class PdfFileDetectorTest extends AbstractP4JavaUnitTest {
  @Test
  public void testIsPdfFile_given_ValidPdf() throws Exception {
    File file = loadFileFromClassPath("com/perforce/p4java/common/io/sample_valid_pdf.pdf");
    boolean actual = PdfFileDetector.isPdfFile(file);
    assertThat(actual, is(true));
  }

  @Test
  public void testIsPdfFile_given_validPdf_headMagicNumber_but_its_a_text_file() throws Exception {
    File file = loadFileFromClassPath("com/perforce/p4java/common/io/sample_have_valid_pdf_head_magic_number_but_it_is_a_text.pdf");
    boolean actual = PdfFileDetector.isPdfFile(file);
    assertThat(actual, is(false));
  }

  @Test
  public void testIsPdfFile_given_valid_v1_4_Pdf() throws Exception {
    File file = loadFileFromClassPath("com/perforce/p4java/common/io/sample_v1_4_pdf.pdf");
    boolean actual = PdfFileDetector.isPdfFile(file);
    assertThat(actual, is(true));
  }
}